
/* Compatible models:
 *      -
 *      -
 *      -
 *      -
 *      -
 *      -
 *      -
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "DYNASCAN_RS232";

/*
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 1
}

Screen.prototype.maxAttempts = {
    power : 1,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/

//Conf
Screen.prototype.portValues = {
        name : '',
        config : {
                baudRate : 115200,
                dataBits : 8,
                stopBits : 1
        },
        parser : {
            type : 'byteLength' ,
            delimiter : 10
        }
}

//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    console.log (id)
    console.log (Buffer.from ( ( "00" + id.toString(16)).substr(-2) , 'hex'))
    return ( "00" + id.toString(16)).substr(-2)

};

Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var command = Buffer.from ( this.data.formated_remote_id + '4E' + '00000000000001' + 'AA' , 'hex');
    return command;
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('hex');
    //console.log ( new Date() + ' - ' + this.name + ', screen: '+ this.data.id + " : Result check power status: " + this.status.lastCMD );
    if(data.length == 10 ) {
        if ( data[5] >= 128 ){
            this.status.power = 1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
            this.attemptsCounter.power = this.maxAttempts.power;
        }else {
            this.status.power = 0;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
            this.attemptsCounter.power = this.maxAttempts.power;
        }
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.power = -1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};



Screen.prototype.endPowerQuerry = function (){
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var command = Buffer.from ( this.data.formated_remote_id + '38' + '00000000000001' + 'AA' , 'hex');
    return command;
};


Screen.prototype.translateChannelQuerry = function ( data ){
    //no channel control
    //TODO:
    /*if (data.includes( Buffer.from ('', 'hex') )){
        this.status.channel = 'HDMI';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from ('EF040201', 'hex') )){
        this.status.channel = 'VGA';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from ('EF040200', 'hex') )){
        this.status.channel = 'OTHER';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.channel = 'Unknown';
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }*/
    return;
};


Screen.prototype.endChannelQuerry = function (){};

/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
        this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
        return;
    };

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var command = Buffer.from ( this.data.formated_remote_id + '54' + '80000000000000' + 'AA' , 'hex');
    return command;
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };


Screen.prototype.generateOffQuerry  = function (){
    var command = Buffer.from ( this.data.formated_remote_id + '54' + '00000000000000' + 'AA' , 'hex');
    return command;
};
Screen.prototype.translateOffQuerry = function ( data ){ return; };


/******************************** FREE COMMAND: REBOOT PROTOTYPING ********************************/
Screen.prototype.singularRebootAvailable = true;
//Screen.prototype.allRebootAvailable = true;


/******************************** FREE COMMAND: CUSTOM PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( commandRecived ){
    return Buffer.from ( commandRecived , 'hex');

};
Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };
